'##############################################################################################################
#Define TSNE_DEF_REUSER
#include once "TSNE_V3.bi"



'##############################################################################################################
Enum SCORESERV_CMD_Enum
	SCORESERV_HELLO				= 1
	SCORESERV_GAMEID			= 2
	SCORESERV_LEVEL				= 3
	SCORESERV_LEVELDAT			= 4
	SCORESERV_NICK				= 5
	SCORESERV_SCORE				= 6
	SCORESERV_TIME				= 7
	SCORESERV_SOLVE				= 8
	SCORESERV_LIST				= 9
	SCORESERV_CHECK				= 10
	SCORESERV_CHECKLEVEL		= 11
	SCORESERV_ERR				= 12
	SCORESERV_OK				= 13
	SCORESERV_FAIL				= 14
	SCORESERV_MODEL				= 15
End Enum



'##############################################################################################################
Dim Shared ScoreServ_INT_DATA as String
Dim Shared ScoreServ_INT_TX as String
Dim Shared ScoreServ_INT_RX as String
Dim Shared ScoreServ_INT_RETURN as SCORESERV_CMD_Enum



'##############################################################################################################
Function ScoreServ_INT_MakeStream(V_CMD as SCORESERV_CMD_Enum, V_Data as String = "") as String
Dim T as String = Chr(V_CMD) & V_Data
Dim TL as UInteger = Len(T)
Return Chr((TL shr 24) and 255, (TL shr 16) and 255, (TL shr 8) and 255, (TL and 255)) & T
End Function



'##############################################################################################################
Function ScoreServ_INT_GetINTVal(V_Data as UInteger) as String
Return Chr((V_Data shr 24) and 255, (V_Data shr 16) and 255, (V_Data shr 8) and 255, (V_Data and 255))
End Function



'##############################################################################################################
#IFDEF TSNE_SUBCALLBACK
Sub ScoreServ_INT_TSNE_NewData(ByVal V_TSNEID as UInteger, ByRef V_Data as String, ByVal V_CallBackPtr as Any Ptr)
#ELSE
Sub ScoreServ_INT_TSNE_NewData(ByVal V_TSNEID as UInteger, ByRef V_Data as String)
#ENDIF
'Print "[NDA]: " & Str(Len(V_Data)) & " >" & V_Data & "<"
ScoreServ_INT_RX += V_Data
Do
	If Len(ScoreServ_INT_RX) < 4 Then Exit Sub
	Dim TL as UInteger = (ScoreServ_INT_RX[0] shl 24) or (ScoreServ_INT_RX[1] shl 16) or (ScoreServ_INT_RX[2] shl 8) or ScoreServ_INT_RX[3]
	If TL > 65535 Then TSNE_Disconnect(V_TSNEID): Exit Sub
	If Len(ScoreServ_INT_RX) < TL + 4 Then Exit Sub
	Dim CMD as SCORESERV_CMD_Enum = ScoreServ_INT_RX[4]
	Dim T as String = Mid(ScoreServ_INT_RX, 6, TL - 1)
	ScoreServ_INT_RX = Mid(ScoreServ_INT_RX, TL + 5)
'	Print "CMD: "; CMD; " >"; Len(T); "<"
	Select Case CMD
		Case SCORESERV_HELLO
			TSNE_Data_Send(V_TSNEID, ScoreServ_INT_TX)
			
		Case SCORESERV_ERR, SCORESERV_OK, SCORESERV_FAIL
			ScoreServ_INT_RETURN = CMD
			
		Case SCORESERV_LIST
			ScoreServ_INT_DATA = T
			ScoreServ_INT_RETURN = CMD
			
	End Select
Loop
End Sub



'##############################################################################################################
Function ScoreServ_GetList(V_GameName as String, V_Level as UInteger, R_ScoreNick() as String, R_ScoreTime() as UInteger, R_ScoreValue() as UInteger, ByRef R_ScoreC as UInteger) as Integer
R_ScoreC = 0
ScoreServ_INT_RETURN = SCORESERV_ERR
If V_GameName	= "" Then Return ScoreServ_INT_RETURN
If V_Level		<= 0 Then Return ScoreServ_INT_RETURN
ScoreServ_INT_DATA = ""
ScoreServ_INT_RX = ""
ScoreServ_INT_TX = ""
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_GAMEID, V_GameName)
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_LEVEL, ScoreServ_INT_GetINTVal(V_Level))
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_LIST)
Dim TTSNEID as UInteger
Dim RV as Integer = TSNE_Create_Client(TTSNEID, "deltalabs.de", 44055, 0, 0, @ScoreServ_INT_TSNE_NewData)
'Dim RV as Integer = TSNE_Create_Client(TTSNEID, "localhost", 44055, 0, 0, @ScoreServ_INT_TSNE_NewData)
TSNE_WaitClose(TTSNEID)
Dim XLen as UInteger
Do
	If Len(ScoreServ_INT_DATA) < 16 Then Exit Do
	XLen = *Cast(UInteger Ptr, @ScoreServ_INT_DATA[0])
	If Len(ScoreServ_INT_DATA) < XLen Then Exit Do
	R_ScoreC += 1
	Redim Preserve R_ScoreNick(R_ScoreC) as String
	Redim Preserve R_ScoreTime(R_ScoreC) as UInteger
	Redim Preserve R_ScoreValue(R_ScoreC) as UInteger
	R_ScoreNick(R_ScoreC) = Mid(ScoreServ_INT_DATA, 21, XLen - 16)
	R_ScoreValue(R_ScoreC) = Cast(UInteger Ptr, @ScoreServ_INT_DATA[0])[1]
	R_ScoreTime(R_ScoreC) = Cast(UInteger Ptr, @ScoreServ_INT_DATA[0])[2]
	ScoreServ_INT_DATA = Mid(ScoreServ_INT_DATA, XLen + 5)
Loop
Return ScoreServ_INT_RETURN
End Function



'##############################################################################################################
Function ScoreServ_Add(V_GameName as String, V_Level as UInteger, V_InvModel as UInteger, V_ScoreNick as String, V_ScoreTime as UInteger, V_ScoreValue as UInteger, V_LevelData as String = "", V_SolveData as String = "") as Integer
ScoreServ_INT_RETURN = SCORESERV_ERR
If V_GameName	= "" Then Return ScoreServ_INT_RETURN
If V_Level		<= 0 Then Return ScoreServ_INT_RETURN
If V_ScoreNick	= "" Then Return ScoreServ_INT_RETURN
If V_ScoreValue	<= 0 Then Return ScoreServ_INT_RETURN
ScoreServ_INT_DATA = ""
ScoreServ_INT_RX = ""
ScoreServ_INT_TX = ""
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_GAMEID, V_GameName)
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_LEVEL, ScoreServ_INT_GetINTVal(V_Level))
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_NICK, V_ScoreNick)
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_SCORE, ScoreServ_INT_GetINTVal(V_ScoreValue))
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_MODEL, ScoreServ_INT_GetINTVal(V_InvModel))
If V_ScoreTime > 0 Then ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_TIME, ScoreServ_INT_GetINTVal(V_ScoreTime))
If V_LevelData <> "" Then ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_LEVELDAT, V_LevelData)
If V_SolveData <> "" Then ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_SOLVE, V_SolveData)
ScoreServ_INT_TX += ScoreServ_INT_MakeStream(SCORESERV_CHECK)
Dim TTSNEID as UInteger
Dim RV as Integer = TSNE_Create_Client(TTSNEID, "deltalabs.de", 44055, 0, 0, @ScoreServ_INT_TSNE_NewData)
'Dim RV as Integer = TSNE_Create_Client(TTSNEID, "localhost", 44055, 0, 0, @ScoreServ_INT_TSNE_NewData)
TSNE_WaitClose(TTSNEID)
Return ScoreServ_INT_RETURN
End Function



'##############################################################################################################
Function ScoreServ_CheckNewLevels(V_GameName as String, ByRef R_LevelC as UInteger) as Integer
Return -1
End Function




